/*
** Copyright (C) 2019 HARMAN Connected Services
** All rights reserved
**
** This software embodies materials and concepts which are
** confidential to HARMAN Connected Services and is made available solely
** pursuant to the terms of a written license agreement with
** HARMAN Connected Services.
**
** Designed and Developed by HARMAN Connected Services
**
*/
#ifndef MATRIX4_H_HEADER_INCLUDED
#define MATRIX4_H_HEADER_INCLUDED

class Matrix4
{
public:
    Matrix4 ();

    bool operator== (const Matrix4 &matrix) const;
    bool operator!= (const Matrix4 &matrix) const;

    float &operator[] (int i);
    float operator[] (int i) const;

    Matrix4 operator* (float factor) const;
    Matrix4 operator* (const Matrix4 &matrix) const;
    Matrix4 operator+ (const Matrix4 &matrix) const;
    Matrix4 operator- (const Matrix4 &matrix) const;

    Matrix4 &operator*= (float factor);
    Matrix4 &operator*= (const Matrix4 &matrix);
    Matrix4 &operator+= (const Matrix4 &matrix);
    Matrix4 &operator-= (const Matrix4 &matrix);

    void zero ();
    void identity ();
    void rotate (float angle, float x, float y, float z);
    void scale (float x, float y, float z);
    void translate (float x, float y, float z);

    void ortho(float left, float right, float bottom, float top, float znear, float zfar);

    float  mat[16];
};

#endif /* MATRIX4_H_HEADER_INCLUDED */
