#include <QGuiApplication>
#include <QQuickView>
#include "HmiPostProcessingManager.h"
#include <QDebug>

int main(int argc, char *argv[])
{
    bool inv(true);
    if (argc == 2)
    {
        qInfo() << "Run inversive colors Lut";
        inv = false;
    }
    else
    {
        qInfo() << "Run straight colors Lut";
    }

    QGuiApplication app(argc, argv);
    const QUrl url(QStringLiteral("qrc:/main.qml"));

    QQuickView *view = new QQuickView;
    view->setSource(url);
    HmiPostProcessingManager m_postProcessingManager;
    m_postProcessingManager.setLutInversion(inv);
    m_postProcessingManager.registrate(HmiPostProcessingManager::HmiScreenId::Central, view);
    m_postProcessingManager.initialize();
    view->show();

    return app.exec();
}
